﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'Scale Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
' Scaling formula
'	Delta = ((100%x + 100%y) / (320dip + 430dip) - 1)
'	Rate = 0.5 'value between 0 to 1. 
'	Scale = 1 + Rate * Delta

	Public Rate As Double
	Rate = 0.3 'value between 0 to 1. 
End Sub

'Gets the scale with the Rate set with SetScaleRate 
'or with the default Rate value of 0.3
Sub GetScale As Double

	Return (1 + Rate * ((100%x + 100%y) / (320dip + 430dip) - 1))
End Sub

'Sets the scale rate
'Exemple:
'Set the value to 0.5
'<code>Scale.SetScaleRate(0.5)</code>
Sub SetScaleRate(cRate As Double)
	Rate = cRate
End Sub

'Gets the phyiscal screen size in inches
'Exemple:
'<code>DeviceSize = Scale.GetDevicePhysicalSize</code>
Sub GetDevicePhysicalSize As Float
	Dim lv As LayoutValues

	lv = GetDeviceLayoutValues
	Return Sqrt(Power(lv.Height / lv.Scale / 160, 2) + Power(lv.Width / lv.Scale / 160, 2))
End Sub

'Scales the view v with the Rate set with SetScaleRate
'or with the default Rate value of 0.3
Sub ScaleView(v As View)
	Dim cScale As Double
	
	cScale = 1 + Rate * ((100%x + 100%y) / (320dip + 430dip) - 1)


	v.SetLayout(v.Left * cScale, v.Top * cScale, v.Width * cScale, v.Height * cScale)
	If v Is Label Then 'this will catch ALL views with text (EditText, Button, ...)
		Dim lbl As Label = v
		lbl.TextSize = lbl.TextSize * cScale
	End If
End Sub

'Scales all views in the given Activity or Panel with all its child views
'with the the Rate set with SetScaleRate
'or with the default Rate value of 0.3
Sub ScaleAll(act As Activity)
	Dim i As Int
	
	' test if the activity object is a Panel
	'If GetType(act) = "anywheresoftware.b4a.BALayout" Then
	'	' if yes scale it
	'	Msgbox("pre","")
	'	ScaleView(act)
	'End If
	'Msgbox("post","")
	For i = 0 To act.NumberOfViews - 1
		Dim v As View
		v = act.GetView(i)
		ScaleView(v)
		If GetType(v) = "anywheresoftware.b4a.BALayout" Then
			' test if the view is a Panel
			' if yes calls the ScaleAll routine 
			ScaleAll(v)
		Else If GetType(v) = "anywheresoftware.b4a.objects.ScrollViewWrapper$MyScrollView" Then
			' test if the view is a ScrollView
			' if yes calls the ScaleAll routine with ScrollView.Panel
			Dim scv As ScrollView
			scv = v
			ScaleAll(scv.Panel)
		'Else If GetType(v) = "flm.b4a.scrollview2d.ScrollView2DWrapper$MyScrollView" Then
			' test if the view is a ScrollView2D
			' if yes calls the ScaleAll routine with ScrollView2D.Panel
			'Dim scv2d As ScrollView2D
			'scv2d = v
			'ScaleAll(scv2d.Panel)
		End If
	Next
End Sub
